/*  DEMO4350.C
 *
 *  Demo for 43(EGA) and 50(VGA) line modes under Turbo C.
 *  From PC Magazine (V9#8, April 24, 1990, p. 333).
 */

#include <conio.h>
#include <dos.h>
#include <stdlib.h>

#define VIDEO_BIOS 0x10

int setfont8x8(int mode);
void setstdfont(int mode);
void main(void);

void main(void)
{
    int lines,i;

    lines=setfont8x8(C80);
    textattr(WHITE);
    clrscr();

    if (lines < 43){
        textattr(LIGHTRED);
        cprintf("No EGA or VGA present\r\n");
        exit(1);
    }

    window(20,15,70,35);
    textattr((RED<<4)+WHITE);
    clrscr();
    for (i=15 ; i<=35 ; i++)
        cprintf("\r\n Line %d",i);

    window(45,5,77,lines);
    textattr((MAGENTA<<4)+YELLOW);
    clrscr();
    for (i=5 ; i<=lines-1 ; i++)
        cprintf("\r\n Line %d",i);
    cprintf("\r\n HIT A KEY");

    getch();

    window(1,1,80,lines);
    textattr(LIGHTGRAY<<4);
    clrscr();
    cprintf("\r\n Whole screen 80x%d display\r\n",lines);
    cprintf("\r\n HIT A KEY");
    getch();

    lines=setfont8x8(C40);
    textattr((BLUE<<4)+LIGHTGREEN);
    clrscr();
    cprintf("\r\n There is also a 40x%d mode\r\n",lines);
    cprintf("\r\n HIT A KEY");
    getch();

    setstdfont(C80);
    clrscr();
    cprintf("\r\n Just called setstdfont().... back in 80x25\r\n");
    cprintf("\r\n HIT A KEY TO EXIT");
    getch();

    exit(0);
}


/* use the EGA/VGA 8x8 font to display 43/50 lines text */
int setfont8x8(int mode)
{
    int maxlines,maxcol;
    char vtype,displaytype;

    textmode(mode);                       /* set text mode          */

    _AH=0x0F;                             /* get video status       */
    geninterrupt(VIDEO_BIOS);             /* call video bios        */
    maxcol=_AH;

    _AX=0x1A00;                           /* get video display      */
    geninterrupt(VIDEO_BIOS);
    displaytype=_AL;
    vtype=_BL;                            /* save active display    */

    if (displaytype == 0x1A){             /* if VGA/MCGA supported  */
        switch (vtype){
            case 4:                       /* EGA color              */
            case 5:                       /* EGA monochrome         */
                   maxlines=43;
                   break;
            case 7:                       /* VGA analog mono        */
            case 8:                       /* VGA analog color       */
            case 11:                      /* MCGA analog mono       */
            case 12:                      /* MCGA analog color      */
                   maxlines=50;
                   break;
            default:                      /* something else         */
                   maxlines=25;
                   break;
        }
    }else{                                /* look for EGA           */
        _AH=0x12;                         /* get video config.      */
        _BL=0x10;
        geninterrupt(VIDEO_BIOS);
        if (_BL == 0x10)                  /* EGA not supported      */
            maxlines=25;
        else
            maxlines=43;
    }
    if (maxlines > 25){
        _AX=0x1112;                       /* set font 8x8           */
        _BL=0;
        geninterrupt(VIDEO_BIOS);
        _AX=0x1103;                       /* use font 8x8           */
        _BL=0;
        geninterrupt(VIDEO_BIOS);
    }
    *((char *)&directvideo-8)=maxlines;   /* set max # lines        */
    window(1,1,maxcol,maxlines);
    return(maxlines);
}


/* reset 80x25 mode */
void setstdfont(int mode)
{
    if (mode != LASTMODE)
        _AL=mode;
    else{
        _AH=0x0F;
        geninterrupt(VIDEO_BIOS);
        mode=_AL;
    }

    _AH=0;
    geninterrupt(VIDEO_BIOS);

    *((char *)&directvideo-8)=25;         /* reset max lines        */
    textmode(mode);                       /* update Turbo C's vars  */
}
